#!/bin/sh

#
# minprocmail.sh - un procmail minimum
#

FicTemp=/tmp/`basename $0`.$$

cd `dirname $0`

. ./commun-minprocmail

[ -z "$PATH" ] && export PATH=/bin:/usr/bin
[ -z "$HOME" ] && export HOME=`grep "^\`whoami\`:" /etc/passwd | cut -d: -f6`

[ ! -f $FicConf ] && echo "$FicConf: no such file" && exit 1

[ "$1" = "-v" ] && Verbose="y"

rm -f /tmp/separe-mels.sh.*
if [ -x ./separe-mels.sh ]
then
    [ "$Verbose" = "y" ] && ./separe-mels.sh -v || ./separe-mels.sh
fi

ls /tmp/separe-mels.sh.* > /dev/null 2>&1 || exit 0

ChercheRegexpHeader ()
{
    tr -d '\r' | while read ligne
    do
        [ -z "$ligne" ] && return 1
        egrep -i "$regexp" $message > /dev/null && return 0
    done
}

for message in /tmp/separe-mels.sh.*
do
    [ "$Verbose" = "y" ] && echo -n "$message"
    #FoundBAL="n"
    rm -f $FicTemp
    #for regexp in `grep "^ *\*" $FicConf | sed "s/^ *\* *//"`
    grep "^ *\*" $FicConf | sed "s/^ *\* *//" | while read regexp
    do
        if ChercheRegexpHeader < $message
        then
            RegexpConf=`echo "$regexp" | sed "s/^\^//"`
            ListeBal=`egrep -v "^ *#|^ *[a-zA-Z]+ *= *" $FicConf | sed "/^ *:0:/,/$RegexpConf/d"`
            if [ -n "$ListeBal" ]
            then
                for bal in $ListeBal
                do
                    bal=`eval echo $bal`
                    Dir=`dirname $bal`
                    [ -d $Dir ] || mkdir -p $Dir
                    [ "$Verbose" = "y" ] && echo -n " -> $bal"
                    #FoundBAL="y"
                    : > $FicTemp
                    #cat $message >> $bal
                    tr -d '\r' < $message >> $bal
                    echo >> $bal
                done
            else
                echo >&2 "Warning: no box for $RegexpConf"
            fi
        fi
    done

    #if [ "$FoundBAL" != "y" ]
    if [ ! -f $FicTemp ]
    then
        BAL=`eval echo $BAL`
        Dir=`dirname $BAL`
        [ -d $Dir ] || mkdir -p $Dir
        [ "$Verbose" = "y" ] && echo -n " -> $BAL"
        #cat $message >> $BAL
        tr -d '\r' < $message >> $BAL
        echo >> $BAL
    fi
    [ "$Verbose" = "y" ] && echo "."
done

rm -f $FicTemp
rm -f /tmp/separe-mels.sh.*

